"""Setuptools configuration."""
import os

from setuptools import find_packages, setup

import versioneer

HERE = os.path.dirname(os.path.abspath(__file__))


def extract_requires():
    """Get pinned requirements from requirements.txt."""
    with open(os.path.join(HERE, 'requirements/requirements.txt'), 'r') as reqs:
        return [line.split(' ')[0] for line in reqs if not line[0] in ('-', '#')]


setup(
    name='incorporeal-cms',
    description='Flask project for running https://suou.net (and eventually others).',
    url='https://git.incorporeal.org/bss/incorporeal-cms',
    author='Brian S. Stephan',
    author_email='bss@incorporeal.org',
    license='AGPLv3+',
    classifiers=[
        'License :: OSI Approved :: GNU Affero General Public License v3 or later (AGPLv3+)',
    ],
    version=versioneer.get_version(),
    cmdclass=versioneer.get_cmdclass(),
    packages=find_packages(),
    include_package_data=True,
    zip_safe=False,
    install_requires=extract_requires(),
    extras_require={
        'dot': ['pydot'],
    },
)
